
Redmine - Feature #37674

Upgrade Admin/Users list to use the query system

2022-09-14 04:38 - Jens Krämer

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Administration Estimated time: 0.00 hour

Target version: 5.1.0   

Resolution: Fixed   

Description

This patch series that was extracted from Planio introduces a UserQuery

and upgrades the Admin/Users list with corresponding filter, sort and (CSV) export capabilities.

Also introduced are a context menu and an option to delete multiple users at once. The third patch just

adds flash messages to the (single) user deletion operation, for symmetry with the messages rendered by the bulk delete.

This relates to issues #4295, #18193, #21055 (probably there are more I didn't find).

Related issues:

Related to Redmine - Feature #4295: Support more filters on the user list page Closed 2009-11-26

Related to Redmine - Feature #18193: Add ability to filter users list by Auth... Closed

Related to Redmine - Patch #21055: Add Authentication mode filter in the User... Closed

Related to Redmine - Feature #4023: User Custom Fields in List view Closed 2009-10-13

Related to Redmine - Feature #11501: More filters on page admin -> users Closed

Related to Redmine - Feature #31043: Search/filter users in backend Closed

Related to Redmine - Defect #38182: Exporting users query does not use the qu... Closed

Related to Redmine - Patch #39181: /users backwards API compatibility Closed

Has duplicate Redmine - Feature #5017: Custom columns on Admin/Users page Closed 2010-03-09

Has duplicate Redmine - Feature #36659: Add "auth_source_id" to GET request f... Closed

Has duplicate Redmine - Feature #13529: to allow query with parameters for Us... Closed

Associated revisions

Revision 21823 - 2022-09-20 05:16 - Go MAEDA

Introduces a UserQuery model for admin/users (#37674).

Patch by Jens Krämer.

Revision 21824 - 2022-09-20 05:36 - Go MAEDA

User bulk destroy (#37674).

includes a confirmation page that also gives the opportunity to lock

users instead of deleting them.

Patch by Jens Krämer.

Revision 21825 - 2022-09-20 05:37 - Go MAEDA

Confirm user update / deletion (#37674).

Patch by Jens Krämer.

Revision 21826 - 2022-09-20 05:46 - Go MAEDA

Update locales (#37674).

Revision 21828 - 2022-09-21 08:01 - Go MAEDA

Adds tests for UserQuery model (#37674).

Patch by Jens Krämer.
Revision 21835 - 2022-09-24 06:54 - Go MAEDA

Fix random test failure (#37674).

Revision 21856 - 2022-09-27 11:30 - Go MAEDA

Adds missing join when ordering by authsource (#37674).

Patch by Jens Krämer.

Revision 21860 - 2022-09-27 21:36 - Marius BĂLTEANU

Fix failing test on PostgreSQL by ordering by only non null values (#37674).

Revision 21861 - 2022-09-27 21:55 - Marius BĂLTEANU

Fix undefined method  when auth source name column is added as column (#37674).

Revision 22046 - 2023-01-16 09:46 - Go MAEDA

Remove code no longer necessary due to r21823 (#37674).

Revision 22121 - 2023-03-01 09:47 - Go MAEDA

Exporting UserQuery does not use the query name as file name (#37674, #38182).

Patch by Takenori TAKAKI.

Revision 22343 - 2023-10-15 03:42 - Go MAEDA

API compatibility to legacy status and name query params (#39181, #37674)

- adds 'name' filter that mimics the old behavior of matching on email, login, first- or lastname

- maps the 'status' url parameter to the status_id filter, and the 'name' url parameter to the new name filter

Patch by Jens Krämer.

Revision 22344 - 2023-10-15 03:44 - Go MAEDA

Update locales (#39181, #37674).

History

#1 - 2022-09-15 05:48 - Go MAEDA

- File screenshot-20220915.png added

Screenshot of this feature:
#2 - 2022-09-15 06:40 - Go MAEDA

Thank you for posting the nice improvement. However, the following error occurred with SQLite.

Error:

UsersControllerTest#test_index_with_name_filter:

ActiveRecord::StatementInvalid: SQLite3::SQLException: no such function: CONCAT

    app/controllers/users_controller.rb:54:in `index'

    lib/redmine/sudo_mode.rb:61:in `sudo_mode'

    test/functional/users_controller_test.rb:54:in `test_index_with_name_filter'

rails test test/functional/users_controller_test.rb:53

 Could you update the patch to support SQLite? In my environment, I was able to fix the error with the following code.

--- app/models/user_query.rb.org    2022-09-15 13:34:22.000000000 +0900

+++ app/models/user_query.rb    2022-09-15 13:34:41.000000000 +0900

@@ -134,8 +134,13 @@

   def sql_for_name_field(field, operator, value)

     match = operator == '~'

-    name_sql = sql_contains("CONCAT(login, ' ', firstname, ' ', lastname)",

-                            value.first, match: match)

+    if Redmine::Database.sqlite?

+      name_sql = sql_contains("login || ' ' || firstname || ' ' || lastname",

+                              value.first, match: match)

+    else

+      name_sql = sql_contains("CONCAT(login, ' ', firstname, ' ', lastname)",

+                              value.first, match: match)

+    end

     emails = EmailAddress.table_name

     email_sql = <<-SQL

#3 - 2022-09-15 07:40 - Jens Krämer

- File 0001-introduces-a-UserQuery-model-for-admin-users.patch added

Thank you for looking into this. Attached is the first patch with your solution built in.

#4 - 2022-09-15 10:00 - Go MAEDA

This patch uses the "name" filter to search three columns: first name, last name, and email. I think this follows the current search feature. However, I

think it may be confusing for users to use the "name" filter to search for email addresses. Actually, neither I nor two of my colleagues could not find a
way to search by email until I read the patch.

What about extracting the email address search from the "name" filter and adding a separate "email" filter?

#5 - 2022-09-15 13:11 - Jens Krämer

Good point. I indeed tried to stay close to the existing functionality with this combined name filter, but maybe that's not really necessary after all.

I also just noticed that support for the other filter operators like 'starts with' / 'ends with' is still missing. I'll come up with an updated patch soon.

#6 - 2022-09-15 18:07 - Marius BĂLTEANU

I agree that each user attribute should have its specific filter.

#7 - 2022-09-16 01:43 - Jens Krämer

- File 0003-confirm-user-update-deletion.patch added

- File 0002-user-bulk-destroy.patch added

- File 0001-introduces-a-UserQuery-model-for-admin-users.patch added

Please find attached a new series of patches with the following changes:

reduced number of commits by merging the last commit (auth source filter and column) into the first.

separate filters for login, firstname, lastname, mail

fixed the mail filter to support all string operators

#8 - 2022-09-17 07:31 - Go MAEDA

- Target version set to 5.1.0

Setting the target version to 5.1.0.

#9 - 2022-09-20 05:40 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed patches with fixes of RuboCop warnings. Thank you for providing this improvement.

#10 - 2022-09-20 05:52 - Go MAEDA

- Related to Feature #4295: Support more filters on the user list page added

#11 - 2022-09-20 05:54 - Go MAEDA

- Related to Feature #18193: Add ability to filter users list by Authentication mode added

#12 - 2022-09-20 05:55 - Go MAEDA

- Related to Patch #21055: Add Authentication mode filter in the Users admin page added

#13 - 2022-09-20 05:56 - Go MAEDA

- Tracker changed from Patch to Feature

- Resolution set to Fixed

#14 - 2022-09-20 07:42 - Mischa The Evil

- Related to Feature #4023: User Custom Fields in List view added

#15 - 2022-09-20 07:42 - Mischa The Evil

- Related to Feature #11501: More filters on page admin -> users added

#16 - 2022-09-20 07:43 - Mischa The Evil

- Related to Feature #31043: Search/filter users in backend added

#17 - 2022-09-21 06:06 - Jens Krämer

- File 0001-adds-tests-for-UserQuery-model-37674.patch added
- Status changed from Closed to Reopened

I just noticed that I forgot to add the tests for the new UserQuery model.

#18 - 2022-09-21 08:01 - Go MAEDA

- Status changed from Reopened to Closed

Jens Krämer wrote:

I just noticed that I forgot to add the tests for the new UserQuery model.

 Committed the code in r21828. Thank you.

#19 - 2022-09-27 00:27 - Marius BĂLTEANU

- Status changed from Closed to Reopened

There is an SQL error when sorting the users list by column Authentication Mode. Te reproduce, go to users page, add the Authentication Mode to

the users list and order by the same column:

PG::UndefinedTable: ERROR: missing FROM-clause entry for table "auth_sources" LINE 1: ...ers"."type" = $2 AND 

(users.status <> 0) ORDER BY auth_sourc... ^

 I've tested only on postgresql, but from a quick check, it seems that the table auth_sources is not joined, but the table is used in the sort. Can you

check, please?

#20 - 2022-09-27 03:44 - Jens Krämer

- File 0001-adds-missing-join-when-ordering-by-authsource-37674.patch added

My bad, I didn't override  joins_for_order_statement to account for that. Attached patch fixes this.

#21 - 2022-09-27 11:31 - Go MAEDA

- Status changed from Reopened to Closed

Jens Krämer wrote:

My bad, I didn't override  joins_for_order_statement to account for that. Attached patch fixes this.

 Committed the fix. Thank you for quickly writing the fix.

#22 - 2022-09-27 14:58 - Go MAEDA

- Status changed from Closed to Reopened

The test fails with PostgreSQL.

Failure:

UserQueryTest#test_auth_source_ordering [/var/lib/jenkins/workspace/trunk/DATABASE_ADAPTER/postgresql/RUBY_VER

/ruby-3.1/test/unit/user_query_test.rb:182]:

--- expected

+++ actual

@@ -1 +1 @@

-#<User id: 1, login: "admin", hashed_password: [FILTERED], firstname: "Redmine", lastname: "Admin", admin: tr

ue, status: 1, last_login_on: "2006-07-19 20:57:52.000000000 +0000", language: "en", auth_source_id: 1, create

d_on: "2006-07-19 17:12:21.000000000 +0000", updated_on: "2006-07-19 20:57:52.000000000 +0000", type: "User", 

mail_notification: "all", salt: "82090c953c4a0000a7db253b0691a6b4", must_change_passwd: false, passwd_changed_

on: nil, twofa_scheme: nil, twofa_totp_key: nil, twofa_totp_last_used_at: nil, twofa_required: false>

+#<User id: 2, login: "jsmith", hashed_password: [FILTERED], firstname: "John", lastname: "Smith", admin: fals

e, status: 1, last_login_on: "2006-07-19 20:42:15.000000000 +0000", language: "en", auth_source_id: nil, creat

ed_on: "2006-07-19 17:32:09.000000000 +0000", updated_on: "2006-07-19 20:42:15.000000000 +0000", type: "User",

 mail_notification: "all", salt: "67eb4732624d5a7753dcea7ce0bb7d7d", must_change_passwd: false, passwd_changed

_on: nil, twofa_scheme: nil, twofa_totp_key: nil, twofa_totp_last_used_at: nil, twofa_required: false>

rails test test/unit/user_query_test.rb:172

#23 - 2022-09-27 21:38 - Marius BĂLTEANU
Go MAEDA wrote:

The test fails with PostgreSQL.

[...]

 I've fixed the test in r21860 by adding a new AuthSource and ordering by non null values. I think the problem is generated by how PostgreSQL

handles the null values by default.

#24 - 2022-09-27 22:00 - Marius BĂLTEANU

I've fixed another issue in r21861 that appears when the column auth source name is added as column and at least one user has an auth source

different than internal:

Error:

UsersControllerTest#test_index_with_auth_source_column:

ActionView::Template::Error: undefined method `visible?' for #<AuthSourceLdap id: 1, [...]>

 Please let me know what do you think about the fix.

#25 - 2022-09-28 09:15 - Jens Krämer

That looks good to me. Thanks Marius!

#26 - 2022-09-28 09:17 - Marius BĂLTEANU

- Status changed from Reopened to Closed

Jens Krämer wrote:

That looks good to me. Thanks Marius!

 Thanks! All tests pass now, closing this.

#27 - 2023-01-16 03:20 - Go MAEDA

- Related to Defect #38182: Exporting users query does not use the query name as file name added

#28 - 2023-03-27 14:59 - Go MAEDA

- Has duplicate Feature #5017: Custom columns on Admin/Users page added

#29 - 2023-10-11 14:03 - Holger Just

- Related to Patch #39181: /users backwards API compatibility  added

#30 - 2024-01-25 17:45 - Marius BĂLTEANU

- Has duplicate Feature #36659: Add "auth_source_id" to GET request for Endpoint /users.:format added

#31 - 2024-01-25 17:47 - Marius BĂLTEANU

- Has duplicate Feature #13529: to allow query with parameters for Users of REST API added

Files

0002-user-bulk-destroy.patch 6.5 KB 2022-09-14 Jens Krämer

0001-introduces-a-UserQuery-model-for-admin-users.patch 30.4 KB 2022-09-14 Jens Krämer

0003-confirm-user-update-deletion.patch 971 Bytes 2022-09-14 Jens Krämer

0004-adds-column-and-filter-for-authentication-mode-to-ad.patch 3.2 KB 2022-09-14 Jens Krämer

screenshot-20220915.png 238 KB 2022-09-15 Go MAEDA

0001-introduces-a-UserQuery-model-for-admin-users.patch 30.6 KB 2022-09-15 Jens Krämer

0002-user-bulk-destroy.patch 6.5 KB 2022-09-15 Jens Krämer

0003-confirm-user-update-deletion.patch 971 Bytes 2022-09-15 Jens Krämer

0001-introduces-a-UserQuery-model-for-admin-users.patch 31.7 KB 2022-09-15 Jens Krämer

0001-adds-tests-for-UserQuery-model-37674.patch 5.86 KB 2022-09-21 Jens Krämer

0001-adds-missing-join-when-ordering-by-authsource-37674.patch 1.67 KB 2022-09-27 Jens Krämer

Powered by TCPDF (www.tcpdf.org)

2025-05-17 6/6

https://www.redmine.org/projects/redmine/repository/svn/revisions/21860
https://www.redmine.org/projects/redmine/repository/svn/revisions/21861
http://www.tcpdf.org

